//+------------------------------------------------------------------+
//|                                                       NeoLan.mq4 |
//+------------------------------------------------------------------+

extern string     _;
extern double     Lot=0.1;
extern int        FirstProfit=10;

extern string     __;
extern int        MartProf=10;
extern double     exp=1.6;
extern int        step=50;          


extern string     _;
extern int        slippage=3;
extern int        Magic1=341;    
extern int        Magic2=342;

int start()
  {
  //-------------------------------------------------------------------//
  
    
   for(int m=1; m<=OrdersTotal(); m++)          
    { 
      OrderSelect(m-1,SELECT_BY_POS);
      int type=OrderType();
      double lots=OrderLots();
      double price1=OrderOpenPrice();
      double price2=OrderClosePrice();
      double tp=OrderTakeProfit();
      double sl=OrderStopLoss();
      double pr1=OrderProfit();
      int ticket=OrderTicket();
      int mn=OrderMagicNumber();
      datetime time=OrderOpenTime();
            
      int ko1,ko2,ko3,ko4,ko5,ko6;
      
      if (mn==Magic1 && type==0)
      ko1=ko1+1;
      
      if (mn==Magic1 && type==2)
      ko2=ko2+1;
      
      if (mn==Magic2 && type==1)
      ko3=ko3+1;
      
      if (mn==Magic2 && type==3)
      ko4=ko4+1; 
      
      
    }  

    
    double balans[1];    
    double prbp[1];
    double prsp[1];
    
    //-------------------------  -----------------------//
    
    double prb1=GetProfitOpenPosInPoint(NULL, 0, Magic1);
    double prs1=GetProfitOpenPosInPoint(NULL, 1, Magic2);
    
    if(ko1==0)
    ArrayInitialize(prbp,0);
    
    prbp[0]=NormalizeDouble(prb1+MartProf*Point,Digits);
    
    if(ko3==0)
    ArrayInitialize(prsp,0);
    
    prsp[0]=NormalizeDouble(prs1-MartProf*Point,Digits);
    
  //----------------- , --------------//
  
    

    for(int m1=1; m1<=OrdersTotal(); m1++)          
    { 
      OrderSelect(m1-1,SELECT_BY_POS);
      double lots1=OrderLots();
      int type1=OrderType();
      double price11=OrderOpenPrice();
      double price21=OrderClosePrice();
      int ticket1=OrderTicket();
      int mn1=OrderMagicNumber();
      double tp1=OrderTakeProfit();
      double sl1=OrderStopLoss();
      
      
      if (type1==0 && ko1>1 && mn1==Magic1 && tp1>prbp[0])
      OrderModify(ticket1,price11,0,prbp[0],0);
      
      if (type1==1 && ko3>1 && mn1==Magic2 && tp1<prsp[0])
      OrderModify(ticket1,price11,0,prsp[0],0);
      
      
      
     if (ko1==0  && ko2>0 && type1==2)
     OrderDelete(ticket1);
     
     if (ko3==0  && ko4>0 && type1==3)
     OrderDelete(ticket1);

    }
     
     //----------------------------------------------------//
    
    if (ko1==0 )
    OrderSend(Symbol(),OP_BUY,Lot,Ask,slippage,0,Ask+FirstProfit*Point,"NL",Magic1);

    if (ko3==0) 
    OrderSend(Symbol(),OP_SELL,Lot,Bid,slippage,0,Bid-FirstProfit*Point,"NL",Magic2);
       
    //-------------------------Martin-----------------------------//
    
    
     
    
    
     if (ko2==0 && ko1>0)
    {
    double  iLot=Lot*MathPow(exp,ko1-1);
    OrderSend(Symbol(),OP_BUYLIMIT,iLot,Ask-step*Point,slippage,0,5,"NL",Magic1);
    }
    
    if (ko4==0 && ko3>0)
    {
    iLot=Lot*MathPow(exp,ko3-1);
    OrderSend(Symbol(),OP_SELLLIMIT,iLot,Bid+step*Point,slippage,0,0,"NL",Magic2);    
    }
    
    
    
     
    
   
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------//


double GetAmountLotFromOpenPos(string sy="", int op=-1, int mn=-1) {
  double l=0;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if (OrderSymbol()==sy || sy=="") {
        if (OrderType()==OP_BUY || OrderType()==OP_SELL) {
          if (op<0 || OrderType()==op) {
            if (mn<0 || OrderMagicNumber()==mn) {
              l+=OrderLots();
            }
          }
        }
      }
    }
  }
  return(l);
}

double GetProfitOpenPosInPoint(string sy="", int op=-1, int mn=-1) {
  double p,pr;
  int    i, k=OrdersTotal();

  if (sy=="0") sy=Symbol();
  for (i=0; i<k; i++) {
    if (OrderSelect(i, SELECT_BY_POS, MODE_TRADES)) {
      if ((OrderSymbol()==sy || sy=="") && (op<0 || OrderType()==op)) {
        if (mn<0 || OrderMagicNumber()==mn) {
          p=MarketInfo(OrderSymbol(), MODE_POINT);
          if (p==0) if (StringFind(OrderSymbol(), "JPY")<0) p=0.0001; else p=0.01;
          if (OrderType()==OP_BUY) {
            pr+=(OrderOpenPrice()*OrderLots())/GetAmountLotFromOpenPos(NULL, 0, Magic1);
          }
          if (OrderType()==OP_SELL) {
            pr+=(OrderOpenPrice()*OrderLots())/GetAmountLotFromOpenPos(NULL, 1, Magic2);
          }
        }
      }
    }
  }
  return(pr);
}



